/*MOUSEKEEPER version 1.0*/
/*  COMMAND LIST
 * w  - вперед
 * s  - назад
 * a  - влево
 * d  - впарво
 * q  - стоп
 * f  - лазер вкл/выкл
 * c  - смена режима
 * e  - управление шторкой
 * g  - управление мостом
 * o  - автоматическое круговое движение
 */

/* LIST OF MODES
  * 0 - Стандартный
  * 1 - Экономия
  * 2 - Тест-режим
  * Режим переключается использованием клавиши c + цифра (Пр. c0)
*/
  
#define up 0
#define down 170
#define reg 3
#include <AFMotor.h>
#include <Servo.h>
#define mod_speed_left 225
#define mod_speed_right 200
Servo shtora;
Servo most;
int light_lvl = 0;
int mode = 0;
int cnt = 0;
int echo = A0;
int sm = 100;
int trig = A1;
int kostil = 0;
int fwdd = 5000;
int lftd = 3150;
int stpd = 1000;
int rgtd = 2750;

char a[10];
boolean laser = true;
boolean low_power = false;
boolean mouse = false;
boolean shtorka = false;
AF_DCMotor motor1(3);
AF_DCMotor motor2(2);


void setup() {
  laser = true;
  mode = 0;
  shtora.attach(9);
  shtora.write(up);
  most.attach(10);
  pinMode(echo, INPUT);
  pinMode(trig, OUTPUT);  
  pinMode(A2, OUTPUT);  
  pinMode(A3, OUTPUT);  //лазер вкл/выкл
  pinMode(A4, OUTPUT);  //Светодиод
  pinMode(A5, INPUT);  //фотодиод?
  Serial.begin(9600);
  most.write(10);
  curr_light();
}

void loop() {
  if(Serial.available()>0){
    for(int i = 0; i<10; i++){
      a[i]=Serial.read();
      delay(10); 
    }
  }
switch (a[0]){
  case 'o':
    krug();
  break;
  case 'g':
    switch (a[1]){
      case '0':
        most_ctr(0);
      break;
      case '1':
        most_ctr(1);
      break;    
    }
  break;
  case 'w':
    forward();
    delay(100);
  break;
  case 's':
    backward();
    delay(100);
  break;
  case 'a':
    left();
    delay(50);
  break;
  case 'd':
    right();
    delay(50);
  break;
  case 'q':
    stoi();
    a[0]='0';
  break;
  case 'f':
    if(laser == false){
      vkloff(1);
      Serial.println("laser=ON");
      laser = true;
    }
    else{
      vkloff(0);
      Serial.println("Laser=OFF");
      laser = false;
    }
    a[0]='0';
  break;
  case 'c':
    switch (a[1]){
      case '0':
        Serial.println("Mode=0");
        mode = 0;
      break;
      case '1':
        Serial.println("Mode=1");
        mode = 1;
      break;
      case '2':
        mode=2;
        handctr();
      break;
      case '3':
        mode=3;
        Test();
      break;
    }
    a[0]='0';
    a[1]='x';
  break;
  case 'e':
    if(a[1]=='0'){
      Serial.println("Servo_down");
      shtora.write(down);
      shtorka=true;
    }
    if(a[1]=='1'){
      Serial.println("Servo_up");
      shtora.write(up);
      shtorka=false;
    }
    a[0]='0';
    a[1]='x';
  break; 
  case 't':
    telem();
    a[0]='0';
  break; 
}
switch (mode){
  case 0:
    standard();
  break;
  case 1:
    low_elect();
  break;
  case 2:
    Test();
  break;
  
}


  
}
/*************/

void forward(){
  most_ctr(1);
  Serial.println("FORWARD");
  motor1.setSpeed(mod_speed_left); 
  motor2.setSpeed(mod_speed_right);
  motor1.run(BACKWARD);
  motor2.run(BACKWARD);
  delay(30);
}

void right(){
  most_ctr(1);
  Serial.println("RIGHT");
  motor1.setSpeed(mod_speed_left); 
  motor2.setSpeed(mod_speed_right);
  motor1.run(BACKWARD);
  motor2.run(RELEASE);
  delay(30); 
}

void left(){
  most_ctr(1);
  Serial.println("LEFT");
  motor1.setSpeed(mod_speed_left); 
  motor2.setSpeed(mod_speed_right);
  motor1.run(RELEASE);
  motor2.run(BACKWARD);
  delay(10);
}

void stoi(){
  most_ctr(0);
  Serial.println("STOP");
  motor1.run(RELEASE);
  motor2.run(RELEASE);
}

void Proverka_sveti(){
  if(laser == true){
    //Serial.println("svet_ON");
    int sveta = analogRead(A5); 
    if(sveta<light_lvl-60){
      kostil = 1;
      shtora.write(down);
      shtorka=true;
    }
    else{
      kostil = 0;
    }
  }
}

void vkloff(int x){
  switch (x){
    case 0:
      laser=false;
      //Serial.println("OFF");
      digitalWrite(A3,LOW);
    break;
    case 1:
      laser=true;
      //Serial.println("ON")
      digitalWrite(A3,HIGH);
    break;
  }
}

void backward(){
  Serial.println("NE MOGU, KOZHANIY MESHOK, IDI NAFIG");
  Serial.println("БУНД!");
  stoi();
  a[0]='c';
  a[1]='0';
}

void telem(){
  Serial.print("Mode=");
  Serial.println(mode);
  Serial.print("Laser=");
  Serial.println(laser);
  Serial.print("Mouse=");
  Serial.println(mouse);
  Serial.print("Gate=");
  Serial.println(shtorka);
}

void standard(){
  most_ctr(0);
  vkloff(1);
  Proverka_sveti();
}

void low_elect(){
  most_ctr(0);
  vkloff(0);
  Rast();
  if(sm <= reg){
      Serial.println("Servo_down");
      shtora.write(down);
      shtorka=true;
      mouse=true;
  }
}

void Rast(){
  int dur;
  digitalWrite(trig, LOW);
  delayMicroseconds(2);
  digitalWrite(trig,HIGH);
  delayMicroseconds(10);
  digitalWrite(trig,LOW);
  dur = pulseIn(echo,HIGH);
  sm = dur/58;
  delay(100);
}

void Test(){
 delay(1000);
 forward();
 delay(1000);
 stoi();
 delay(1000);
 shtora.write(down);
 delay(1000);
 shtora.write(up);
 delay(100);
 most_ctr(1);
 delay(500);
 most_ctr(0);
 digitalWrite(A3,LOW);
 delay(100);
 digitalWrite(A3,HIGH);
 mode = 0;
 Serial.println("TEST COMPETE");    
}

void curr_light(){
  if(laser == true){
    light_lvl = analogRead(A5);
  }
  delay(200);
  digitalWrite(A3,LOW);
  delay(200);
  digitalWrite(A3,HIGH);
  delay(200);
  digitalWrite(A3,LOW);
  delay(200);
  digitalWrite(A3,HIGH);
  delay(200);
  digitalWrite(A3,LOW);
}

void most_ctr(int ctr){
  switch (ctr){
    case 0:
      most.write(10);
    break;
    case 1:
      most.write(180);
    break;
  }
}
void krug(){
  forward();
  delay(fwdd);
  left();
  delay(lftd);
  forward();
  delay(fwdd);
  left();
  delay(lftd);
  stoi();
  delay(stpd);
  right();
  delay(rgtd);
  stoi();
  a[0]='c';
  a[1]='0';
}

void handctr(){
  
}

